(load "init.lisp")
(load "hp.lisp")

;organization

(defparameter *default-mass* 10.0)
(defmacro incr (x) `(setf ,x (+ ,x 1)))

(setq *strict-atoms* t)
(setq dom-penalty 2)   ;penalty for every "unguarded dom"
(setq disj-penalty 2)  ;penalty for every new disjunction

(defun weigh (c)
(* (* disj-penalty (- (length (clause-rhs c))) 0.5)
   (* dom-penalty (1+ (length (domain-deficit c)))))
)

;maximum value the mass can take
(let ((maxm (make-mass :v *default-mass*)))
(defun max-mass (&optional new)
(if new (setf (mass-v maxm) new) maxm)
))

(setq *avh*
'(:not (:forall (x) (:imp (d x) (:exists (y) (d y))))))

(setq ex6 '(:not 
(:imp (:forall (x y) (:or (a x) (b y)))
      (:or (:forall (x) (a x)) (:forall (y) (b y)))
)))

(setq ex13
'(:not (:or (:exists (x) (:and (p x) (q x))) 
	    (:forall (y) (:imp (p y) (:not (q y)))))))

(setq ex34
'(:not (:imp (:exists (x y z)
		      (:and (:or (P x y z) (Q) )
			    (:or (:not (P x y z) (Q)))
			    )))))

(setq p33
'(:not (:eqv
    (:forall (x) (:imp (:and (p (a)) (:imp (p x) (p (b))))
		       (p (c))))
    (:forall (x) (:and (:or (:not (p (a))) (p x) (p (c)))
		       (:or (:not (p (a))) (:not (p (b))) (p (c)))))
)))

(setq p43
'(:not (:imp
(:forall (x y) (:eqv (q x y) (:forall (z) (:eqv (p z x) (p z y)))))
(:forall (x y) (:eqv (q x y) (q y x))))))

(setq p36
'(:not (:imp (:and
   (:forall (x) (:exists (y) (j x y)))
   (:forall (x) (:exists (y) (g x y)))
   (:forall (x y) (:imp (:or (j x y) (g x y))
			(:forall (z) (:imp (:or (j y z) (g y z))
					   (h x z))))))
(:forall (x) (:exists (y) (h x y))))))
