;gives the list of variables which occur on the left but not on the right
(defun domain-deficit (c)
(set-difference (apply #'union* (mc (x) (formula-freevars (node-formula x)) (clause-rhs c)))
		(apply #'union* (mc (x) (formula-freevars (node-formula x)) (clause-lhs c)))
))

;used in tnf.lisp
(defun dual (op)
(case op
(:and :or)
(:or :and)
(:exists :forall)
(:forall :exists)
(otherwise op)
))

;used in pre.lisp
(defun istrue (s) (eq s :true))
(defun isfalse (s) (eq s :false))

;used in translator.lisp
(defun flip (pole)
(case pole
(:pos :neg)
(:neg :pos)
(:t :f)
(:f :t)
(t pole)
))

;used in writer.lisp
(defun get-cl-nodes (cs)
(if (endp cs) nil
    (union (remove-if (lambda (n) (formula-atom (node-formula n))) (cl-clause-lhs (car cs)))
	   (get-cl-nodes (cdr cs)))))

;used in runner.lisp
(defun funs-of (f)
(reverse (parsedata-funs (cdr (parse-formula (tnf f) *empty-data*)))))

;an easy test case
(setq *dpe2*
'(:AND 
  (:NOT (GOAL)) 
  (:AND (REFLEXIVE_REWRITE (A) (B)) (REFLEXIVE_REWRITE (A) (C)))
  (:FORALL (A) (:IMP (:AND (REFLEXIVE_REWRITE (B) A) (REFLEXIVE_REWRITE (C) A)) (GOAL))) 
  (:FORALL (A) (EQUALISH A A))
  (:FORALL (A B) (:IMP (EQUALISH A B) (EQUALISH B A)))
  (:FORALL (A B C) (:IMP (:AND (EQUALISH A B) (REFLEXIVE_REWRITE B C)) (REFLEXIVE_REWRITE A C)))
  (:FORALL (A B) (:IMP (EQUALISH A B) (REFLEXIVE_REWRITE A B))) 
  (:FORALL (A B) (:IMP (REWRITE A B) (REFLEXIVE_REWRITE A B)))
  (:FORALL (A B) (:IMP (REFLEXIVE_REWRITE A B) (:OR (EQUALISH A B) (REWRITE A B))))
  (:FORALL (A B C) (:IMP (:AND (REWRITE A B) (REWRITE A C)) (:EXISTS (D) (:AND (REWRITE B D) (REWRITE C D)))))))

(setq *dpe*
'(:AND 
  (:NOT (GOAL)) 
  (:AND (RE (A) (B)) (RE (A) (C)))
  (:FORALL (A) (:IMP (:AND (RE (B) A) (RE (C) A)) (GOAL))) 
  (:FORALL (A) (E A A))
  (:FORALL (A B) (:IMP (E A B) (E B A)))
  (:FORALL (A B C) (:IMP (:AND (E A B) (RE B C)) (RE A C)))
  (:FORALL (A B) (:IMP (E A B) (RE A B))) 
  (:FORALL (A B) (:IMP (R A B) (RE A B)))
  (:FORALL (A B) (:IMP (RE A B) (:OR (E A B) (R A B))))
  (:FORALL (A B C) (:IMP (:AND (R A B) (R A C)) (:EXISTS (D) (:AND (R B D) (R C D)))))))
