;reads the given theory into the "formula" data structure
(defun parse (f)
  (car (parse-formula (tnf f) *empty-data*)))

(defun parse-formula (tree data)
(if (atom tree) (cons nil (format t "a tree with atomic shit~%"))
(case (car tree)
((:and :or)
 (let* ((a (rd (acc elt)
	       (let* ((e (parse-formula elt (cdr acc)))
		       (eform (car e))
		       (edata (cdr e)))
		  (cons (cons eform (car acc))
			edata))
	       (cons nil data)
	       (cdr tree)))
	(arglist (nreverse (car a)))
	(adata (cdr a)))
   (cons (make-formula
	  :head (car tree)
	  :args arglist
	  :freevars (apply 'union* (mapcar 'formula-freevars arglist)))
	 adata)
))
((:exists :forall)
 (let* ((a (parse-formula (third tree) data))
	(arg (car a))
	(adata (cdr a)))
   (cons (make-formula
	  :head (car tree)
	  :args arg
	  :freevars (set-difference (formula-freevars arg) (second tree))
          :bindlist (second tree))
	 adata)
))
((:t :f)
 (let* ((p (second tree))
	(a (rd (acc elt)
	       (let* ((e (parse-term elt (cdr acc)))
		      (eform (car e))
		      (edata (cdr e)))
		 (cons (cons eform (car acc))
		       edata))
	       (cons nil data)
	       (cdr p)))
	(arglist (nreverse (car a)))
	(newdata (cdr a))
	(prevp (assoc (car p) (parsedata-preds newdata)))
	(pred (if prevp 
		  (cdr prevp)
		  (let ((pnodes (acons :t (make-node :formula :atom :pole :pos)
			        (acons :f (make-node :formula :atom :pole :neg) nil))))
		    (make-atompred
		     :head (car p)
		     :arity (length (cdr p))
		     :nodes (cdr (rplacd (cdr pnodes) pnodes))
		   ))))
	(adata (if prevp 
		   newdata
		   (make-parsedata
		    :preds (cons (cons (car p) pred) (parsedata-preds newdata))
		    :funs (parsedata-funs newdata)
		    :vars (parsedata-vars newdata))
        )))
   (cons (make-formula
	  :head (car tree)
	  :args arglist
	  :freevars (apply 'union* (mapcar 'term-freevars arglist))
	  :atom pred)
	 adata)
))
(t (format t "The tree's been fucked.~%") (cons nil nil))
)))

(defun parse-term (trm data)
(cond
((null trm) (list (format t "No term :[") data))
((atom trm) 
 (cons (make-term
	:freevars (list trm)
	:var trm)
       (make-parsedata
	:preds (parsedata-preds data)
	:funs  (parsedata-funs data)
	:vars (adjoin trm (parsedata-vars data)))
))
(t
 (let* ((a (rd (acc elt)
	       (let* ((e (parse-term elt (cdr acc)))
		      (eform (car e))
		      (edata (cdr e)))
		 (cons (cons eform (car acc))
		       edata))
	       (cons nil data)
	       (cdr trm)))
	(arglist (nreverse (car a)))
	(newdata (cdr a))
	(prevf (assoc (car trm) (parsedata-funs newdata)))
	(adata (if prevf
		   newdata
		   (make-parsedata
		    :preds (parsedata-preds newdata)
		    :funs (acons (car trm) (length (cdr trm)) (parsedata-funs newdata))
		    :vars (parsedata-vars newdata))
	)))
   (cons (make-term
	  :head (car trm)
	  :args arglist
	  :freevars (apply 'union* (mapcar 'term-freevars arglist)))
	 adata)
))))
