;axiomize: presents the input as a list of atoms, disjunctions, and existentials
(labels
( (axioms (bvs f)
    (case (first f)
;     (:forall (axioms (union bvs (second f)) (third f)))
     (:and (apply #'append (mc (c) (axioms bvs c) (rest f))))
     (t (list (cons bvs f)))))
  (sort-atoms (lst) 
     (funcall (make-binary-sort (lambda (f) (member (cadr f) '(:t :f)))) lst))
  (sort-disjs (lst)
     (funcall (make-binary-sort (lambda (f) (eq (cadr f) :or))) lst))
  (good-atom (a)
     (let ((bvs (car a)) (trs (cdaddr a)))
       (and (subsetp trs bvs)
	    (>= (length bvs) (length trs))))) )
(defun axiomize (formula)
;: formula --> List formula
(let* ((axs (axioms nil formula))
       (lst (sort-atoms axs))
       (ats (car lst))
       (flg (cdar (remove-if-not #'good-atom ats)))
       (nxt (if flg (propcalc (car (second flg))
			      (if (eq (car flg) :t) :true :false)
			      formula))))
  (if flg
      (if (atom nxt)
	  (format t "The theory is ~s!!~%" nxt)
	  (axiomize (tnf nxt)))
      (append ats (cdr lst)))
)))

;propositional calculator
(defun propcalc (var val formula)
;: atompred * {:true :false} * formula --> formula
(case (first formula)
((:exists :forall)
 (let ((arg (propcalc var val (third formula))))
   (case arg
     (:true  :true)
     (:false :false)
     (t (list (first formula) (second formula) arg)))))
(:and
 (let ((args (mc (f) (propcalc var val f) (rest formula))))
   (cond
   ((some #'isfalse args) :false)
   ((every #'istrue args) :true)
   (t (cons :and (remove-if #'istrue args))))))
(:or
 (let ((args (mc (f) (propcalc var val f) (rest formula))))
   (cond
   ((every #'isfalse args) :false)
   ((some #'istrue args) :true)
   (t (cons :or (remove-if #'isfalse args))))))
(:t (if (eq (car (second formula)) var)
	(if (eq val :true)  :true :false)
	formula))
(:f (if (eq (car (second formula)) var)
	(if (eq val :false) :true :false)
	formula))
(otherwise (format t "Error in propcalc.~%"))
))
