;fix the bug in marc's output

(defun cl (f &optional name)
(let* ((axioms (axiomize (tnf f)))
       (parsed (parse-formula (cons :and (mapcar #'cdr axioms)) *empty-data*))
       (funs (reverse (parsedata-funs (cdr parsed))))
       (theories (launch (formula-args (car parsed)) (max-mass)))
       (normalized (mapcar #'sort-clauses theories))
       (final (if (member nil normalized)
		  (list nil)
		  (sort normalized #'< :key (lambda (x) (mass-v (theory-mass x))))
       )))
(setq *pred-index-counter* 0)
(cond
((null final) (format t "No Results.~%"))
((equal final (list nil)) (format t "Normalized to nothing.~%"))
((eq name :return) final)
((eq name :nonorm) theories)
((or (null name) (eq name :display))
   (print-out (car final) funs)
   (dolist (i (cdr final)) (format t "~%~%Next theory:~%~%") (print-out i funs)))
(t (write-out final name funs))
)))

(defun test (fs &optional (lim 1000) (prover :john) (outf t))
 ;&key (:raw raw nil))
(if (null fs) nil
(if (atom fs) (test (list fs) lim prover outf)
(let* ((nm (subseq (car fs) 0 (search ".in" (car fs) :from-end t)))
       (fm (fetch-tptp (car fs) :noxl))
       (x (cl fm :return))
       (bam (when (null x) (format outf "No translations found.~%") (return-from test nil)))
       (l (length x))
       (r (ceiling (log l 10))))
   (run-shell-command (format nil "rm ~~/acl/tests/~a/*" nm))
   (write-out x nm (funs-of fm) prover)
   (format outf "~%Processing file: ~s~%" nm)
   (format outf "Number of translations: ~s~%" l)
   (format outf "Prover results:~%")
   (case prover
(:john
   (dotimes (i l)
      (format outf "~v,'0d: Mass = ~8,3f;    ~?~%"
               r i (mass-v (theory-mass (nth i x)))
	      "Result = ~8<~s~>;    Steps = ~7<~s~>;~@[    Time = ~6<~s~> ms~]"
              (test-file (format nil "tests/~a/~a.~v,'0d.in" nm nm r i) lim)))
   (test (cdr fs) lim prover outf))
(:df
 (do* ((s (run-shell-command (format nil "./df-all.sh tests/~a ~s" 
				     nm (floor (/ lim 1000)))
			     :output :stream
			     :wait t))
       (i (read s nil nil) (read s nil nil)))
      ((null i) t)
    (format outf "~?"
	    "File: ~<~s~>; Result: ~2<~s~>;~@[    Time: ~10<~s~> s~]~%"
	    i)
)))))))

(defun test-files (fs lims)
(cond
 ((null lims) (mapcar #'list fs))
 ((atom lims) (test-files fs (list lims)))
 (t (labels ((sieve (lst acc)
        (if (endp lst) (test-files (mapcar #'car acc) (cdr lims))
	    (if (eq (cadar lst) 'no_proof)
	        (sieve (cdr lst) (cons (car lst) acc))
		(cons (car lst) (sieve (cdr lst) acc))))
      ))
    (sieve (mc (i) (cons i (test-file i (car lims))) fs) nil)))
))

(defun test-files2 (fs lims)
(cond
 ((null lims) (mapcar #'list fs))
 ((atom lims) (test-files2 fs (list lims)))
 (t (labels ((sieve (lst acc)
        (if (endp lst) (test-files2 (mapcar #'car acc) (cdr lims))
	    (cond
              ((eq (cadar lst) 'no_proof)
	         (sieve (cdr lst) (cons (car lst) acc)))
              ((eq (cadar lst) 'disproof)
                 (list car lst))
              (t
		 (cons (car lst) (sieve (cdr lst) acc)))))
      ))
    (sieve (mc (i) (cons i (test-file i (car lims))) fs) nil)))
))

(defun test-dir (nm))

; java -jar GeologUI.jar tests/dpe0/dpe0_00.in 10000 0 0 0 0 0 | tail -n 1 
; | sed -e 's/^\([^#]*\)\#\([^#]*\)\#\([^#]*\) inferences\#\(.*\) ms$/\2 \3 \4/'
(defun test-file (f lim &optional (prover :john) params)
(case prover
(:john
 (do
   ((s (run-shell-command 
         (format nil "java -jar GeologUI.jar ~s ~s~{ ~s~}" f lim
		 (or params (make-sequence 'list 5 :initial-element 0)))
         :output :stream
         :wait t))
    (l "/*0*/" (read-line s nil nil)))
   ((equal l "") 
    (do*
       ((str (substitute #\Space #\! (read-line s)) (subseq str (1+ pos)))
        (pos (position #\# str) (position #\# str))
        (res nil (cons (read-from-string str) res)))
       ((null pos) 
         (let ((r (reverse res)))
          (if (and (eq (car r) 'no_proof) (< (cadr r) lim))
              (cons 'disproof (cdr r))
              r)))
      ))))
(:marc
 (let* ((s (run-shell-command (format nil "./cl-all.sh tests/~a ~s" f
	 :output :stream
	 :wait t))
    (l "/*0*/" (read-line s nil nil)))
    (t nil)
)))
(otherwise (format t "Unknown prover."))
))

(defun scramble-clauses (hd tl fs idx)
(cond
((endp tl)
 (with-open-file (f (format nil fs idx) :direction :output)
   (dolist (i hd) (format f i)))
)
(t
 (dotimes (i (length tl))
   (scramble-clauses (cons (nth i tl) hd)
		     (append (subseq tl 0 i)
			     (subseq tl (1+ i)))
		     fs 
		     (cons i idx))
))))
