(defstruct clause
vars
pivot
type
lever
)

(defun freevars (frm)
(case (first frm)
((:and :or) (apply #'union* (mapcar #'freevars (rest frm))))
((:forall :exists) (set-difference (freevars (third frm)) (second frm)))
((:t :f) (remove-if #'listp (rest (second frm))))))

(defun shitify (frm &optional (fvars nil))
(case (first frm)
((:and :or)
 (let ((args (mapcar (lambda (a) (shitify a (freevars a))) (rest frm))))
   (cons (make-clause 
	  :vars nil
	  :pivot (cons (format nil "t~a_~d"
			       (if (eq (first frm) :and) "And" "Or")
			       (incf idx))
		       fvars)
	  :type (first frm)
	  :lever (mapcar (lambda (th) (clause-pivot (first th))) args))
	 (apply #'append args))))
(:forall
 (let ((arg (shitify (third frm) (freevars (third frm)))))
   (cons (make-clause
	  :vars  (second frm)
	  :pivot (cons (format nil "tAll_~d" (incf idx)) fvars)
	  :type :forall
	  :lever (list (clause-pivot (first arg))))
	 arg)))
(:exists
 (let ((arg (shitify (third frm) (freevars (third frm)))))
   (cons (make-clause
	  :vars nil
	  :pivot (cons (format nil "tEx_~d" (incf idx)) fvars)
	  :type (second frm)
	  :lever (list (clause-pivot (first arg))))
	 arg)))
((:t :f)
 (let ((p (second frm)))
   (cons (make-clause
	  :vars nil
	  :pivot (cons (format nil "~(~a~)~s"
				(subseq (format nil "~s" (first frm)) 1)
				(first p))
		       (rest p))
	  :type nil
	  :lever nil)
	 nil)))
(t (format t "big fucking error, you fuck.\n"))
))

(defun puke-atom (a)
(format nil "~a~:[~;(~a)~]"
	(first a)
	(rest a)
	(subseq (format nil "~:[,~;~:*~:{,~:[~s~;~{~(~s~)~}~]~}~]" 
			(mapcar (lambda (arg) (list (listp arg) arg)) (rest a)))
		1)))

(defun puke-clause (c)
(format nil "~25@<~{dom(~a), ~}~a~> => ~@[~{dom(~a), ~}~]~?.~%"
	(clause-vars c)
	(puke-atom (clause-pivot c))
	(if (listp (clause-type c)) (clause-type c))
	(format nil "~~@{~~a~~^~a ~~}" (if (equal (clause-type c) :or) ";" ","))
	(mapcar #'puke-atom
;		(apply (if (member (clause-type c) (list :or :and)) #'rest #'third)
		       (clause-lever c))
))

(defun puke (th)
(format nil "~15@<true~> => ~a.~{~a~}" 
	(puke-atom (clause-pivot (first th)))
	(mapcar #'puke-clause th)))

(defun cl0 (frm)
(setq idx 0)
(let* ((clt (shitify (tnf frm)))
       (atomic (remove-if #'clause-type clt))
       (others (remove-if-not #'clause-type clt))
       (all-atoms (mapcar (lambda (a) (list
	  (subseq (car (clause-pivot a)) 1)
	  (makevars (length (cdr (clause-pivot a))))
	  )) atomic))
       (atoms (reduce (lambda (lst a) (if (assoc (car a) lst :test #'equal) 
					  lst (cons a lst))) 
		      all-atoms :initial-value nil))
       (bot-out (format nil "~:{t~a~@[(~{~s~^,~})~],~:*~:*~
                                f~a~@[(~{~s~^,~})~] => false.~%~}"
			atoms))
       (final (format t "~a~a" bot-out (puke others))))
  final))

(setf ex6 '(:NOT (:IMP (:FORALL (X Y) (:OR (A X) (B Y))) (:OR (:FORALL (X) (A X)) (:FORALL (Y) (B Y))))))
(setf ex13 '(:not (:or
(:exists (x) (:and (p x) (q x)))
(:forall (y) (:imp (p y) (:not (q y)))))))

(setf dpe (quote
(:AND (:NOT (GOAL)) (:AND (RE (A) (B)) (RE (A) (C)))
 (:FORALL (A) (:IMP (:AND (RE (B) A) (RE (C) A)) (GOAL))) (:FORALL (A) (E A A))
 (:FORALL (A B) (:IMP (E A B) (E B A)))
 (:FORALL (A B C) (:IMP (:AND (E A B) (RE B C)) (RE A C)))
 (:FORALL (A B) (:IMP (E A B) (RE A B)))
 (:FORALL (A B) (:IMP (R A B) (RE A B)))
 (:FORALL (A B) (:IMP (RE A B) (:OR (E A B) (R A B))))
 (:FORALL (A B C) (:IMP (:AND (R A B) (R A C)) (:EXISTS (D) (:AND (R B D) (R C D))))))))
